Index: /java/main/src/main/java/com/framsticks/gui/TreeNode.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/TreeNode.java	(revision 98)
@@ -1,480 +1,219 @@
 package com.framsticks.gui;
 
-import com.framsticks.communication.Subscription;
-import com.framsticks.communication.util.LoggingStateCallback;
-import com.framsticks.core.Mode;
+import java.lang.ref.WeakReference;
+import java.util.Iterator;
+import java.util.LinkedList;
+import java.util.List;
+import java.util.concurrent.atomic.AtomicInteger;
+
+import javax.swing.tree.TreePath;
+
+import org.apache.log4j.Logger;
+
+import com.framsticks.core.Node;
 import com.framsticks.core.Tree;
-import com.framsticks.core.TreeOperations;
-import com.framsticks.core.ListChange;
-import com.framsticks.core.Path;
-import com.framsticks.gui.controls.ValueControl;
 import com.framsticks.gui.view.TreeCellRenderer;
 import com.framsticks.params.AccessInterface;
 import com.framsticks.params.CompositeParam;
-import com.framsticks.params.FramsClass;
-import com.framsticks.params.types.*;
-import com.framsticks.remote.*;
+import com.framsticks.params.types.StringParam;
+import com.framsticks.util.FramsticksException;
 import com.framsticks.util.lang.Casting;
-import com.framsticks.util.lang.Holder;
+import com.framsticks.util.lang.Pair;
 import com.framsticks.util.swing.TooltipConstructor;
-import com.framsticks.util.dispatching.ExceptionResultHandler;
-import com.framsticks.util.dispatching.FutureHandler;
-import com.framsticks.util.FramsticksException;
-import com.framsticks.util.Logging;
-import org.apache.log4j.Logger;
-import com.framsticks.util.dispatching.RunAt;
-
-import javax.swing.tree.DefaultMutableTreeNode;
-import java.util.HashMap;
-import java.util.LinkedList;
-import java.util.List;
-import java.util.Map;
-import static com.framsticks.util.lang.Containers.filterInstanceof;
-import com.framsticks.util.swing.TreeNodeUtils;
-import static com.framsticks.core.TreeOperations.*;
-
-/**
- * @author Piotr Sniegowski
- */
-@SuppressWarnings("serial")
-public class TreeNode extends DefaultMutableTreeNode implements NodeListener, ExceptionResultHandler {
-
-	private static final Logger log = Logger.getLogger(TreeNode.class.getName());
-
-	Panel panel;
-
-	final protected Frame frame;
-	final protected TreeAtFrame treeAtFrame;
-
-	final protected Map<EventParam, Subscription<?>> userSubscriptions = new HashMap<>();
-	protected Map<ValueControl, Object> localChanges = null;
-	protected String tooltip;
-	protected String name;
+
+public class TreeNode extends AbstractNode {
+	private static final Logger log = Logger.getLogger(TreeNode.class);
+
+
+	protected static final AtomicInteger counter = new AtomicInteger();
+
+	protected final WeakReference<Object> reference;
 	protected final CompositeParam param;
-	protected String iconName;
-	protected Path path;
-
-	public TreeNode(TreeAtFrame treeAtFrame, final Path path) {
-		this.frame = treeAtFrame.getFrame();
-		assert frame.isActive();
-		this.param = path.getTop().getParam();
-		this.name = this.param.getId();
-		log.debug("creating treenode " + name + ": " + path);
-		this.path = path;
-		this.treeAtFrame = treeAtFrame;
-
-		iconName = TreeCellRenderer.findIconName(name, path.getTextual());
-		tooltip = "?";
-		path.getTree().dispatch(new RunAt<Tree>(this) {
-			@Override
-			protected void runAt() {
-				updateDescriptions(path);
-			}
-		});
-	}
-
-	public void fetch(final Path p) {
-		assert p.getTree().isActive();
-		log.debug("fetching: " + p);
-		p.getTree().get(p, Mode.FETCH, new FutureHandler<Object>(this) {
-			@Override
-			protected void result(Object result) {
-
-			}
-		});
-	}
-
-	protected void reactForFetchResult(final Path p, Exception e) {
-		assert p.getTree().isActive();
-		if (Logging.log(log, "fetch", TreeNode.this, e)) {
-			frame.dispatch(new RunAt<Frame>(this) {
-				@Override
-				protected void runAt() {
-					log.debug("removing node from tree: " + p);
-					frame.treeModel.removeNodeFromParent(TreeNode.this);
-				}
-			});
-			return;
-		}
-		updateChildren(p);
-		frame.dispatch(new RunAt<Frame>(this) {
-			@Override
-			protected void runAt() {
-				//TODO maybe this should be called from some better place
-				useOrCreatePanel();
-			}
-		});
-	}
-
-	protected void postUpdatePath(final Path newPath) {
-		assert !frame.isActive();
-		/** TODO those two actions could be merged into single closure */
-		frame.dispatch(new RunAt<Frame>(this) {
-			@Override
-			protected void runAt() {
-				updatePath(newPath);
-			}
-		});
-		updateDescriptions(newPath);
-	}
-
-	protected void updatePath(Path newPath) {
-		assert frame.isActive();
-		if (!path.isResolved()) {
-			path = newPath;
-			log.debug("updated treenode's path: " + path);
-			return;
-		}
-		if (path.matches(newPath)) {
-			return;
-		}
-		log.debug("removing all children due to path update");
-		this.removeAllChildren();
-		frame.treeModel.nodeStructureChanged(this);
-	}
-
-	public Iterable<TreeNode> childrenIterable() {
-		return filterInstanceof(TreeNodeUtils.children(TreeNode.this, frame.treeModel), TreeNode.class);
-	}
-
-	/** Update children, by removing non existing and adding new ones.
+	protected final Tree tree;
+	protected final List<Pair<WeakReference<Object>, WeakReference<TreeNode>>> children = new LinkedList<>();
+	protected final int number;
+
+	public TreeNode(Tree tree, CompositeParam param, Object object) {
+		this.tree = tree;
+		this.param = param;
+		reference = new WeakReference<Object>(object);
+		number = counter.getAndIncrement();
+	}
+
+	public TreeNode(Node node) {
+		this(node.getTree(), node.getParam(), node.assureResolved().getObject());
+	}
+
+	public Node tryCreateNode() {
+		Object child = lock();
+		if (child == null) {
+			return null;
+		}
+		return new Node(tree, param, child);
+	}
+
+	@Override
+	public int getChildCount() {
+		Object referent = lock();
+		if (referent == null) {
+			return 0;
+		}
+		AccessInterface access = tree.prepareAccess(param).select(referent);
+		final int count = access.getCompositeParamCount();
+		return count;
+	}
+
+	public TreeNode getTreeNodeForChild(Object child) {
+		Iterator<Pair<WeakReference<Object>, WeakReference<TreeNode>>> i = children.iterator();
+		while (i.hasNext()) {
+			Pair<WeakReference<Object>, WeakReference<TreeNode>> p = i.next();
+			Object object = p.first.get();
+			if (object == null) {
+				i.remove();
+				continue;
+			}
+			TreeNode treeNode = p.second.get();
+			if (treeNode == null) {
+				i.remove();
+				continue;
+			}
+			if (object == child) {
+				return treeNode;
+			}
+		}
+		return null;
+
+		// WeakReference<GuiTreeNode> resultReference = children.get(child);
+		// if (resultReference == null) {
+		//	return null;
+		// }
+		// return resultReference.get();
+	}
+
+	@Override
+	public AbstractNode getChild(int number) {
+		Object referent = lock();
+		if (referent == null) {
+			throw new FramsticksException().msg("invalid state - missing referent");
+		}
+		AccessInterface access = tree.prepareAccess(param).select(referent);
+
+		final int count = access.getCompositeParamCount();
+		if (number >= count) {
+			throw new FramsticksException().msg("invalid state - no child");
+		}
+
+		CompositeParam childParam = access.getCompositeParam(number);
+		Object child = access.get(childParam, Object.class);
+		if (child == null) {
+			log.debug("returing dummy node for " + childParam + " in " + referent);
+			return new EmptyNode(childParam);
+		}
+
+		TreeNode result = getTreeNodeForChild(child);
+		if (result != null) {
+			return result;
+		}
+		result = new TreeNode(tree, childParam, child);
+
+		children.add(Pair.make(new WeakReference<Object>(child), new WeakReference<TreeNode>(result)));
+
+		return result;
+
+	}
+
+	public Object lock() {
+		return reference.get();
+	}
+
+	@Override
+	public int getIndexOfChild(AbstractNode child) {
+		final TreeNode treeChild = Casting.tryCast(TreeNode.class, child);
+		if (treeChild == null) {
+			return -1;
+		}
+		final Object childObject = treeChild.lock();
+		final Object parentObject = lock();
+		if (childObject == null || parentObject == null) {
+			return -1;
+		}
+		final AccessInterface access = tree.prepareAccess(param).select(parentObject);
+
+		final int count = access.getCompositeParamCount();
+		for (int i = 0; i < count; ++i) {
+			Object c = access.get(access.getCompositeParam(i), Object.class);
+			if (c == childObject) {
+				return i;
+			}
+		}
+		log.debug(child + " not found in " + this);
+		return -1;
+	}
+
+	/**
+	 * @return the param
 	 */
-	protected void updateChildren(final Path p) {
-		assert p.getTree().isActive();
-		log.debug("updating children of " + this);
-		AccessInterface access = TreeOperations.bindAccess(p.getTree(), p.getTop());
-		final List<Path> childrenPaths = new LinkedList<Path>();
-		/**Prepare path for each child.*/
-		for (CompositeParam param : filterInstanceof(access.getParams(), CompositeParam.class)) {
-			childrenPaths.add(p.appendParam(param).tryFindResolution());
-		}
-
-		/**If some child were found, update in frame context.*/
-		if (childrenPaths.size() > 0) {
-			frame.dispatch(new RunAt<Frame>(this) {
-				@Override
-				protected void runAt() {
-					// TreePath treePath = frame.startChange();
-					updatePath(p);
-					Map<String, TreeNode> current = new HashMap<String, TreeNode>();
-					for (TreeNode n : childrenIterable()) {
-						current.put(n.path.getLastElement(), n);
-					}
-					assert current.size() == TreeNode.this.getChildCount();
-					assert TreeNode.this.getChildCount() == frame.treeModel.getChildCount(TreeNode.this);
-					log.trace("current " + TreeNode.this.getChildCount() + " children: " + current.values());
-					for (Path childPath : childrenPaths) {
-						String e = childPath.getLastElement();
-						if (current.containsKey(e)) {
-							current.remove(e);
-							continue;
-						}
-						log.debug("update: treenode for " + p);
-						TreeNode childNode = new TreeNode(treeAtFrame, childPath);
-
-						frame.addNode(childNode, TreeNode.this);
-					}
-					for (TreeNode n : current.values()) {
-						frame.treeModel.removeNodeFromParent(n);
-					}
-					log.debug("updated children of " + TreeNode.this + ": " + TreeNode.this.getChildCount());
-				}
-			});
+	public CompositeParam getParam() {
+		return param;
+	}
+
+	/**
+	 * @return the tree
+	 */
+	public Tree getTree() {
+		return tree;
+	}
+
+
+	@Override
+	public String toString() {
+		return param.toString();
+	}
+
+	public static Node tryGetNode(TreePath treePath) {
+		return Casting.throwCast(TreeNode.class, treePath.getLastPathComponent()).tryCreateNode();
+	}
+
+	@Override
+	public boolean isLeaf() {
+		Object referent = lock();
+		if (referent == null) {
+			return true;
+		}
+		AccessInterface access = tree.prepareAccess(param).select(referent);
+		return access.getCompositeParamCount() == 0;
+	}
+
+
+	@Override
+	public void render(TreeCellRenderer renderer) {
+		String name = param.getId();
+
+		Object child = lock();
+		if (child != null) {
+			AccessInterface access = tree.prepareAccess(param).select(child);
+
+			StringParam nameParam = Casting.tryCast(StringParam.class, access.getParam("name"));
+
+			if (nameParam != null) {
+				name = access.get(nameParam, String.class);
+			}
+
+			renderer.setToolTipText(new TooltipConstructor()
+				.append("frams", access.getId())
+				.append("java", child.getClass().getCanonicalName())
+				.append("access", access.getClass().getSimpleName())
+				.append("name", name)
+				.append("id", param.getId())
+				.append("object", Integer.toHexString(System.identityHashCode(child)))
+				.append("number", number)
+				.build());
 		} else {
-			log.debug("no children in " + TreeNode.this);
-		}
-	}
-
-	public void select() {
-		final Path p = path;
-
-		p.getTree().dispatch(new RunAt<Tree>(this) {
-			@Override
-			protected void runAt() {
-				final Path updated = (p.isResolved()) ? p : p.tryFindResolution();
-				if (updated.isResolved()) {
-					Logging.log(log, "update", updated, null);
-					fetch(updated);
-					postUpdatePath(updated);
-					return;
-				}
-				p.getTree().resolve(updated, new FutureHandler<Path>(Logging.logger(log, "resolve and select", TreeNode.this)) {
-					@Override
-					protected void result(Path result) {
-						fetch(result);
-						postUpdatePath(result);
-					}
-				});
-			}
-		});
-
-	}
-
-	@Override
-	public String toString() {
-		return path.toString();
-	}
-
-	public final Panel getPanel() {
-		assert frame.isActive();
-		return panel;
-	}
-
-	protected void updateDescriptions(Path p) {
-		assert p.getTree().isActive();
-
-		if (!p.isResolved()) {
-			return;
-		}
-		AccessInterface access = TreeOperations.bindAccess(p);
-
-		final String tooltip = new TooltipConstructor().append("frams", access.getId()).append("java", p.getTopObject().getClass().getCanonicalName()).append("access", access.getClass().getSimpleName()).append("name", name).append("id", param.getId()).append("object", Integer.toHexString(System.identityHashCode(this))).build();
-
-		StringParam nameParam = Casting.tryCast(StringParam.class, access.getParam("name"));
-		final String name = (nameParam != null ? access.get(nameParam, String.class) : path.getTop().getParam().getId());
-
-		frame.dispatch(new RunAt<Frame>(this) {
-			@Override
-			protected void runAt() {
-				TreeNode.this.tooltip = tooltip;
-				TreeNode.this.name = name;
-
-				log.debug("updated descriptions for " + path + ": " + name);
-			}
-		});
-	}
-
-	public void showPanel() {
-		assert frame.isActive();
-		assert panel != null;
-		frame.showPanel(panel);
-	}
-
-	public void fillPanelWithValues() {
-		assert frame.isActive();
-		if (panel == null) {
-			return;
-		}
-		final Path p = path;
-		assert p.isResolved();
-		panel.setCurrentTreeNode(this);
-		p.getTree().dispatch(new RunAt<Tree>(this) {
-			@Override
-			protected void runAt() {
-				AccessInterface access = TreeOperations.bindAccess(p);
-				panel.pullValuesFromLocalToUser(access);
-
-				frame.dispatch(new RunAt<Frame>(this) {
-					@Override
-					protected void runAt() {
-						showPanel();
-					}
-				});
-			}
-		});
-
-	}
-
-	public void useOrCreatePanel() {
-		assert frame.isActive();
-		if (panel != null) {
-			log.trace("panel is already attached: " + path);
-			fillPanelWithValues();
-			return;
-		}
-		if (!path.isResolved()) {
-			log.trace("path is not resolved: " + path);
-			return;
-		}
-
-		CompositeParam param = path.getTop().getParam();
-		panel = treeAtFrame.findPanel(param.computeAccessId());
-		if (panel != null) {
-			log.debug("found prepared panel for: " + path);
-			fillPanelWithValues();
-			return;
-		}
-		final Path p = path;
-		log.debug("preparing panel: " + p);
-		p.getTree().dispatch(new RunAt<Tree>(this) {
-			@Override
-			protected void runAt() {
-				assert p.getTree().isActive();
-				final CompositeParam param = p.getTop().getParam();
-				final FramsClass framsClass = p.getTree().getInfoFromCache(param.getContainedTypeName());
-				frame.dispatch(new RunAt<Frame>(this) {
-					@Override
-					protected void runAt() {
-						panel = treeAtFrame.preparePanel(param, framsClass);
-						fillPanelWithValues();
-					}
-				});
-			}
-		});
-	}
-
-	public String getTooltip() {
-		assert frame.isActive();
-		return tooltip;
-	}
-
-	/*public void subscribe(final EventParam eventParam) {
-		assert browser.isActive();
-		if (hasSubscribed(eventParam)) {
-			log.error(eventParam + " is already subscribed for " + this);
-			return;
-		}
-		Node node = getNode();
-		node.getConnection().subscribe(node.getPath() + "/" + eventParam.getId(), new SubscriptionCallback() {
-			@Override
-			public EventCallback subscribed(final Subscription subscription) {
-				if (subscription == null) {
-					log.error("subscription failed");
-					return null;
-				}
-				if (hasSubscribed(eventParam)) {
-					//abort subscription
-					return null;
-				}
-				userSubscriptions.put(eventParam, subscription);
-				log.debug("subscription succeeded: " + subscription);
-				subscription.setDispatcher(browser);
-				return new EventCallback() {
-					@Override
-					public void call(SourceInterface content) {
-						assert browser.isActive();
-						log.info("event " + subscription + " occurred");
-					}
-				};
-			}
-		});
-
-	}*/
-
-	public boolean hasSubscribed(EventParam param) {
-		assert frame.isActive();
-		return userSubscriptions.containsKey(param);
-	}
-
-	public void unsubscribe(EventParam eventParam) {
-		assert frame.isActive();
-		if (!hasSubscribed(eventParam)) {
-			log.error("could not unsubscribe from " + eventParam);
-			return;
-		}
-		userSubscriptions.get(eventParam).unsubscribe(new LoggingStateCallback(log, "unsubscribed " + eventParam));
-		userSubscriptions.remove(eventParam);
-	}
-
-	// @Override
-	// public void onChildChange(final Child child, ListChange.Action action) {
-	// assert browser.manager.isActive();
-
-	// switch (action) {
-	// case Remove: {
-	// Dispatching.invokeDispatch(browser, browser.manager, new Runnable() {
-	// @Override
-	// public void run() {
-	// assert browser.manager.isActive();
-	// final TreeNode treeNode = (TreeNode) child.getUserObject();
-	// if (treeNode == null) {
-	// log.error("child " + child + " had no tree node attached");
-	// return;
-	// }
-	// browser.invokeLater(new Runnable() {
-	// @Override
-	// public void run() {
-	// assert browser.isActive();
-	// TreePath path = browser.startChange();
-	// //assert treeNode.getParent() == TreeNode.this;
-	// if (treeNode.getParent() != null) {
-	// browser.treeModel.removeNodeFromParent(treeNode);
-	// }
-	// //remove(treeNode);
-	// browser.markNodeChanged(TreeNode.this, path);
-	// }
-	// });
-	// }
-	// });
-	// break;
-	// }
-	// }
-
-	// }
-
-	public String getName() {
-		return name;
-	}
-
-	public String getIconName() {
-		return iconName;
-	}
-
-	@Override
-	public void onUpgrade(Path path) {
-	}
-
-	@Override
-	public void onChange(Path path) {
-	}
-
-	@Override
-	public void onChildChange(Path path, ListChange.Action action) {
-	}
-
-	public final Frame getFrame() {
-		return frame;
-	}
-
-	public boolean changeValue(ValueControl component, Object newValue) {
-		log.debug("changing value of " + component + " to '" + newValue + "'");
-
-		if (localChanges == null) {
-			localChanges = new HashMap<ValueControl, Object>();
-		}
-		localChanges.put(component, newValue);
-
-		return true;
-	}
-
-	public Path getTreePath() {
-		assert frame.isActive();
-		return path;
-	}
-
-	public void pushLocalChanges() {
-		assert frame.isActive();
-		if (localChanges == null) {
-			return;
-		}
-		Map<ValueControl, Object> changes = localChanges;
-		localChanges = null;
-		final Holder<Integer> counter = new Holder<>(changes.size());
-		final Path p = path;
-
-		for (Map.Entry<ValueControl, Object> e : changes.entrySet()) {
-			set(p, e.getKey().getParam(), e.getValue(), new FutureHandler<Integer>(this) {
-				@Override
-				protected void result(Integer flag) {
-					counter.set(counter.get() - 1);
-					if (counter.get() != 0) {
-						return;
-					}
-					log.debug("applied changes for: " + p);
-					frame.dispatch(new RunAt<Frame>(this) {
-						@Override
-						protected void runAt() {
-							fillPanelWithValues();
-						}
-					});
-				}
-
-			});
-		}
-	}
-
-	@Override
-	public void handle(FramsticksException exception) {
-		frame.handle(exception);
-	}
+			renderer.setToolTipText("?");
+		}
+		renderer.setText(name);
+		renderer.setIcon(ImageProvider.loadImage(TreeCellRenderer.findIconName(param)));
+
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/console/ManagedConsole.java	(revision 98)
@@ -3,5 +3,4 @@
 import java.util.LinkedList;
 import java.util.List;
-
 
 import com.framsticks.communication.ClientSideManagedConnection;
@@ -11,4 +10,5 @@
 import com.framsticks.communication.Response;
 import com.framsticks.communication.queries.ApplicationRequest;
+import com.framsticks.core.Mode;
 import com.framsticks.core.Path;
 import static com.framsticks.core.TreeOperations.*;
@@ -17,7 +17,10 @@
 import com.framsticks.params.annotations.AutoAppendAnnotation;
 import com.framsticks.params.annotations.FramsClassAnnotation;
+import com.framsticks.params.types.ListParam;
 import com.framsticks.remote.RemoteTree;
 import com.framsticks.util.FramsticksException;
+import com.framsticks.util.dispatching.Dispatching;
 import com.framsticks.util.dispatching.FutureHandler;
+import com.framsticks.util.dispatching.RunAt;
 import com.framsticks.util.lang.Casting;
 import com.framsticks.util.lang.Containers;
@@ -27,4 +30,5 @@
 @FramsClassAnnotation
 public class ManagedConsole extends InteractiveConsole {
+
 
 	protected RemoteTree tree;
@@ -70,7 +74,11 @@
 	}
 
+
 	@Override
 	protected void findCompletionPropositions(final String prefix) {
 		Pair<CharSequence, CharSequence> command = Request.takeIdentifier(prefix);
+		if (command == null) {
+			return;
+		}
 
 		Casting.throwCast(ApplicationRequest.class, Request.createRequestByTypeString(command.first.toString()));
@@ -90,22 +98,59 @@
 		// final Iterator<String> iterator = Path.splitPath(textual);
 
-		resolve(tree, textual, new FutureHandler<Path>(this) {
+		tryGet(tree, textual, new FutureHandler<Path>(this) {
 
 			@Override
-			protected void result(Path path) {
+			protected void result(final Path path) {
 				if (!textual.startsWith(path.getTextual())) {
 					throw new FramsticksException().msg("invalid state").arg("line", prefix).arg("path", path);
 				}
+				assert path.getTree().isActive();
 
-				List<String> propositions = new LinkedList<String>();
-				String remaining = textual.substring(path.getTextual().length());
-				remaining = Path.PathBuilder.splitPath(remaining).next();
+				final Runnable finalizeCompletion = new Runnable() {
+					@Override
+					public void run() {
+						String remaining = textual.substring(path.getTextual().length());
 
-				for (CompositeParam p : Containers.filterInstanceof(bindAccess(path).getParams(), CompositeParam.class)) {
-					if (p.getId().startsWith(remaining)) {
-						propositions.add(p.getId());
+						String base = prefix.substring(0, prefix.length() - (textual.length() - path.getTextual().length()));
+						if (path.size() > 1) {
+							base = base + "/";
+						}
+
+						if (remaining.startsWith("/")) {
+							remaining = remaining.substring(1);
+						}
+
+						if (remaining.indexOf('/') != -1) {
+							/** It is to long. */
+							return;
+						}
+						final List<String> propositions = new LinkedList<String>();
+						for (CompositeParam p : Containers.filterInstanceof(bindAccess(path).getParams(), CompositeParam.class)) {
+							if (remaining.equals("") || p.getId().startsWith(remaining)) {
+								propositions.add(base + p.getId());
+							}
+						}
+
+						dispatch(new RunAt<ManagedConsole>(ManagedConsole.this) {
+
+							@Override
+							protected void runAt() {
+								processCompletionResult(prefix, propositions);
+							}
+						});
 					}
+				};
+
+				if (path.getTop().getParam() instanceof ListParam) {
+					tree.get(path, Mode.FETCH, new FutureHandler<Path>(ManagedConsole.this) {
+						@Override
+						protected void result(Path result) {
+							finalizeCompletion.run();
+						}
+					});
+					return;
 				}
-				processCompletionResult(prefix, propositions);
+				finalizeCompletion.run();
+
 			}
 		});
@@ -119,3 +164,21 @@
 		connection = tree.getConnection();
 	}
+
+	@Override
+	protected void joinableStart() {
+		super.joinableStart();
+		Dispatching.use(tree, this);
+	}
+
+	@Override
+	protected void joinableInterrupt() {
+		Dispatching.drop(tree, this);
+		super.joinableInterrupt();
+	}
+
+	@Override
+	protected void joinableJoin() throws InterruptedException {
+		Dispatching.join(tree);
+		super.joinableJoin();
+	}
 }
Index: /java/main/src/main/java/com/framsticks/gui/console/TrackConsole.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/console/TrackConsole.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/console/TrackConsole.java	(revision 98)
@@ -1,3 +1,11 @@
 package com.framsticks.gui.console;
+
+import java.awt.BorderLayout;
+import java.awt.event.ActionEvent;
+import java.awt.event.ActionListener;
+
+import javax.swing.Box;
+import javax.swing.BoxLayout;
+import javax.swing.JCheckBox;
 
 import com.framsticks.communication.Connection;
@@ -8,4 +16,7 @@
 @FramsClassAnnotation
 public class TrackConsole extends Console implements ConnectionListener {
+
+	volatile boolean writeOut = true;
+	volatile boolean writeIn = true;
 
 	public TrackConsole() {
@@ -30,13 +41,49 @@
 	}
 
-
 	@Override
 	public void connectionOutgoing(String line) {
-		dispatchWrite(line);
+		if (writeOut) {
+			dispatchWrite(line);
+		}
 	}
 
 	@Override
 	public void connectionIncomming(String line) {
-		dispatchWrite(line);
+		if (writeIn) {
+			dispatchWrite(line);
+		}
+	}
+
+	@Override
+	protected void initializeGui() {
+		super.initializeGui();
+
+		final Box box = new Box(BoxLayout.LINE_AXIS);
+
+		final JCheckBox outCheckbox = new JCheckBox();
+		outCheckbox.setText("Show out");
+		outCheckbox.setSelected(true);
+		outCheckbox.addActionListener(new ActionListener() {
+			@Override
+			public void actionPerformed(ActionEvent arg0) {
+				writeOut = outCheckbox.isSelected();
+			}
+		});
+
+		final JCheckBox inCheckbox = new JCheckBox();
+		inCheckbox.setText("Show in");
+		inCheckbox.setSelected(true);
+		inCheckbox.addActionListener(new ActionListener() {
+			@Override
+			public void actionPerformed(ActionEvent arg0) {
+				writeIn = inCheckbox.isSelected();
+			}
+		});
+
+		box.add(outCheckbox);
+		box.add(Box.createHorizontalStrut(10));
+		box.add(inCheckbox);
+
+		panel.add(box, BorderLayout.PAGE_END);
 	}
 
Index: /java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/CheckBoxControl.java	(revision 98)
@@ -21,5 +21,4 @@
 		super(booleanParam);
 		checkBox = new JCheckBox();
-		checkBox.setEnabled(!isReadOnly());
 		checkBox.addActionListener(new ActionListener() {
 
@@ -52,3 +51,8 @@
 	}
 
+	@Override
+	protected void updateEnabled(boolean enabled) {
+		checkBox.setEnabled(enabled);
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/controls/Control.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/Control.java	(revision 98)
@@ -24,10 +24,11 @@
 	protected ControlOwner owner;
 
+	protected abstract void updateEnabled(boolean enabled);
+
+	private boolean userEnabled = true;
+
 	public Control(Param param) {
 		this.param = param;
 		setName(param.getId());
-
-		this.setEnabled(!param.hasFlag(Flags.READONLY));
-		// TODO: take care of textField exception: setEditable
 	}
 
@@ -38,4 +39,23 @@
 	public void setOwner(ControlOwner owner) {
 		this.owner = owner;
+	}
+
+	/**
+	 * @return the userEnabled
+	 */
+	public final boolean isUserEnabled() {
+		return userEnabled;
+	}
+
+	/**
+	 * @param userEnabled the userEnabled to set
+	 */
+	public final void setUserEnabled(boolean userEnabled) {
+		this.userEnabled = userEnabled;
+		updateEnabled(!isReadonly());
+	}
+
+	public final boolean isReadonly() {
+		return !userEnabled || param.hasFlag(Flags.READONLY);
 	}
 
Index: /java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/ControlOwner.java	(revision 98)
@@ -2,6 +2,7 @@
 
 import javax.swing.JPanel;
+import javax.swing.tree.TreePath;
 
-import com.framsticks.gui.TreeNode;
+import com.framsticks.gui.Frame;
 import com.framsticks.util.dispatching.ExceptionResultHandler;
 
@@ -9,5 +10,6 @@
 
 	public JPanel getPanel();
-	public TreeNode getCurrentTreeNode();
+	public TreePath getCurrentTreePath();
+	public Frame getFrame();
 
 }
Index: /java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/EnumControl.java	(revision 98)
@@ -28,5 +28,4 @@
 		}
 		list.setEditable(false);
-		list.setEnabled(!isReadOnly());
 		list.addItemListener(new ItemListener() {
 			@Override
@@ -61,3 +60,9 @@
 	}
 
+	@Override
+	protected void updateEnabled(boolean enabled) {
+		list.setEnabled(enabled);
+
+	}
+
 }
Index: /java/main/src/main/java/com/framsticks/gui/controls/EventControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/EventControl.java	(revision 98)
@@ -39,4 +39,9 @@
 	}
 
+	@Override
+	protected void updateEnabled(boolean enabled) {
+		button.setEnabled(enabled);
+	}
+
 	/*
 	@Override
Index: /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java
===================================================================
--- /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 97)
+++ /java/main/src/main/java/com/framsticks/gui/controls/ProcedureControl.java	(revision 98)
@@ -3,6 +3,6 @@
 import com.framsticks.core.Tree;
 import com.framsticks.core.Path;
+import com.framsticks.gui.Frame;
 import com.framsticks.gui.Gui;
-import com.framsticks.gui.TreeNode;
 import com.framsticks.params.Param;
 import com.framsticks.params.ValueParam;
@@ -15,4 +15,5 @@
 import javax.swing.*;
 import javax.swing.border.BevelBorder;
+import javax.swing.tree.TreePath;
 
 import org.apache.log4j.Logger;
@@ -20,5 +21,5 @@
 import java.awt.event.ActionEvent;
 import java.awt.event.ActionListener;
-import java.util.HashMap;
+import java.util.IdentityHashMap;
 import java.util.LinkedList;
 import java.util.List;
@@ -32,5 +33,5 @@
 	protected final JButton procedureButton;
 
-	final protected Map<ValueParam, ValueControl> components = new HashMap<>();
+	final protected Map<ValueParam, ValueControl> components = new IdentityHashMap<>();
 
 	public ProcedureControl(ProcedureParam procedureParam) {
@@ -54,9 +55,6 @@
 			@Override
 			public void actionPerformed(ActionEvent e) {
-				TreeNode treeNode = owner.getCurrentTreeNode();
-				assert treeNode != null;
 
-				log.debug("calling " + getParam() + " on " + treeNode);
-				final Path path = treeNode.getTreePath();
+				final Path path = getFrame().getTreeModel().convertToPath(getCurrentTreePath());
 
 				final List<Object> arguments = new LinkedList<Object>();
@@ -93,12 +91,25 @@
 
 	@Override
-	public TreeNode getCurrentTreeNode() {
-		return owner.getCurrentTreeNode();
-	}
-
-	@Override
 	public ProcedureParam getParam() {
 		return (ProcedureParam) param;
 	}
 
+	@Override
+	protected void updateEnabled(boolean enabled) {
+		procedureButton.setEnabled(enabled);
+		for (ValueControl vc : components.values()) {
+			vc.setUserEnabled(enabled);
+		}
+	}
+
+	@Override
+	public Frame getFrame() {
+		return owner.getFrame();
+	}
+
+	@Override
+	public TreePath getCurrentTreePath() {
+		return owner.getCurrentTreePath();
+	}
+
 }
